<template>
    <div>
        <TopInfo :user="user" :collapse="collapse" />
        <el-menu :default-openeds="opened"
                 :collapse="collapse"
                 :background-color="backgroundColor"
                 :text-color="textColor"
                 :active-text-color="activeTextColor">
            <ItemMenu v-for="item in menu"
                      :key="item.uuid"
                      :item="item"
                      :role="role"
                      :menu="menu"
                      :rTextColor="rTextColor"
                      :rActiveTextColor="rActiveTextColor"
            />
        </el-menu>
    </div>
</template>

<script>
    import ItemMenu from './item-menu.vue';
    import TopInfo from './top-info.vue';
    import {Menu} from 'element-ui';


    export default {

        name: 'LeftMenu',

        components: {
            TopInfo,
            ItemMenu,
            'el-menu': Menu,
        },

        props: {
            roles: {
                type: Array,
                default: () => [],
            },
            opened: {
                type: Array,
                default: () => [],
            },
            items: {
                type: Array,
                default: () => [],
            },
            collapse: {
                type: Boolean,
                default: false,
            },
            user: Object,
            backgroundColor: {
                type: String,
                default: '#1b3446',
            },
            textColor: {
                type: String,
                default: '#cfcfcf',
            },
            activeTextColor: {
                type: String,
                default: '#ffffff',
            },
        },

        data: () => ({
            role: [],
            // menu: [],
            rTextColor: '',
            rActiveTextColor: '',
        }),

        created() {
            this.role = this.roles;
            // this.menu = this.converted.sort((a, b) => a.sort - b.sort);
            this.rTextColor = this.textColor;
            this.rActiveTextColor = this.activeTextColor;
        },

        computed: {
            converted() {
                let next = (parent = null) => this.items.filter(item => parent ? item.parent_uuid === parent.uuid : !item.parent_uuid);
                let injectChildren = (items, parent) => {
                    return items.map(item => {
                        let children = next(item);
                        let result = {...item, active: false, parent};
                        if (children.length) {
                            result.children = injectChildren(children, result);
                        }

                        return result;
                    });
                };

                return injectChildren(next(), null);
            },
            menu() { // for reactivity
                return this.converted.sort((a, b) => a.sort - b.sort);
            }
        },

    }
</script>

<style scoped>

</style>
